'use strict';
const async = require('async');
const jsxl = require('../lib/jsxl');

//********************************************************************************************************

//TESTING

//***************************************************************************************************** 


jsxl.useFilters({
	Test: { a: { b: {
		$filter: (context, value, next) => {
			console.log(66, context.parameters);
			next();
		},
		$type: { n: { $any: [Number, Date] } }
	}}}
});

const filter = 'Test'; 


const input = { a: { b: { n: 8}}};
const ctx = new jsxl.Context({ input }); ctx.parameters = { hello: 'world' }

return jsxl(ctx, filter, (err, result) => {
	if (err) {
		console.log(1234, err);
		process.exit();
	}
	console.log(JSON.stringify(result, null, 4)); // JSON.stringify(input, null, 4)
	process.exit();
})


jsxl.compile(
	filter,
	{ inspect: true },
	(err, filter) => { 
		if (err) {
			console.log(123, err);
			process.exit();
		}
		jsxl.execute(ctx, filter, (err, result) => {
			if (err) {
				console.log(234, err);
				process.exit();
			}
			console.log(345, JSON.stringify(result, null, 4)); // JSON.stringify(input, null, 4)
			process.exit();
		});
	}
);
